<template>
  <div class="my-10">
    <h3>Scatter Plot</h3>
    <div id="container">
      <div id="pixi-chart" ref="pixiChart"></div>
      <svg id="d3-chart" ref="d3Chart"></svg>
    </div>
    <div id="debug" ref="debug"></div>
  </div>
</template>

<script>
import * as d3 from "d3";
import * as PIXI from 'pixi.js';

const WHITE = 0xffffff;
const CIRCLE_SIZE = 2;
const PADDING = CIRCLE_SIZE;

export default {
  name: 'PixiScatterPlot',

  data() {
    return {
      pointsCount: 0
    };
  },

  mounted() {
    this.width = 500;
    this.height = 500;
    this.margin = {
      top: 20,
      right: 20,
      bottom: 50,
      left: 50
    };
    this.chartWidth = this.width - this.margin.left - this.margin.right;
    this.chartHeight = this.height - this.margin.top - this.margin.bottom;

    this.chart = d3.select(this.$refs.d3Chart)
      .append("g")
      .attr("transform", `translate(${this.margin.left}, ${this.margin.top})`);
    this.xAxis = this.chart.append("g")
      .attr("transform", `translate(0, ${this.chartHeight})`);
    this.yAxis = this.chart.append("g");
    this.chart.append("text")
      .attr("font-size", 15)
      .attr("text-anchor", "middle")
      .attr("x", this.chartWidth / 2)
      .attr("y", this.chartHeight + 40)
      .text("x-axis");
    this.chart.append("text")
      .attr("font-size", 15)
      .attr("text-anchor", "middle")
      .attr("transform", "rotate(-90)")
      .attr("x", -this.chartHeight / 2)
      .attr("y", -40)
      .text("y-axis");

    this.minX = Infinity;
    this.maxX = -Infinity;
    this.minY = Infinity;
    this.maxY = -Infinity;

    this.x = d3.scaleLinear().domain([undefined, undefined]).range([0, this.chartWidth]);
    this.y = d3.scaleLinear().domain([undefined, undefined]).range([this.chartHeight, 0]);
    this.xAxis.call(d3.axisBottom(this.x));
    this.yAxis.call(d3.axisLeft(this.y));

    this.color = d3.scaleOrdinal().domain([-1, 0, 1]).range(["#F8766D", "#00BA38", "#619CFF"]);

    this.$refs.pixiChart.style.top = `${this.margin.top - PADDING}px`;
    this.$refs.pixiChart.style.right = `${this.margin.right - PADDING}px`;
    this.$refs.pixiChart.style.bottom = `${this.margin.bottom - PADDING}px`;
    this.$refs.pixiChart.style.left = `${this.margin.left - PADDING}px`;
    this.app = new PIXI.Application({
      resizeTo: this.$refs.pixiChart,
      resolution: window.devicePixelRatio,
      autoDensity: true,
      transparent: true,
      // antialias: true,
    });
    this.$refs.pixiChart.appendChild(this.app.view);

    this.appContainer = new PIXI.Container();
    this.appContainer.x = PADDING;
    this.appContainer.y = PADDING;
    this.appContainer.width = this.width;
    this.appContainer.height = this.height;
    this.app.stage.addChild(this.appContainer);

    this.backgroundLayer = new PIXI.Container();
    this.appContainer.addChild(this.backgroundLayer);

    this.pointLayer = new PIXI.Container();
    this.appContainer.addChild(this.pointLayer);

    this.circleTexture = (() => {
      const graphics = new PIXI.Graphics();
      graphics.beginFill(WHITE);
      graphics.drawCircle(CIRCLE_SIZE, CIRCLE_SIZE, CIRCLE_SIZE);

      const region = graphics.getLocalBounds(undefined, true);
      const roundedRegion = new PIXI.Rectangle(Math.floor(region.x), Math.floor(region.y), Math.ceil(region.width), Math.ceil(region.height));
      const texture = this.app.renderer.generateTexture(graphics, PIXI.SCALE_MODES.LINEAR, this.app.renderer.resolution, roundedRegion);

      return texture;
    })();
  },

  methods: {
    createPointGfx(point, i) {
      const pointGfx = new PIXI.Container();
      pointGfx.name = i;
      pointGfx.x = this.x(point["x"])+ 0.5;
      pointGfx.y = this.y(point["y"]) + 0.5;
      pointGfx.hitArea = new PIXI.Circle(0, 0, CIRCLE_SIZE);

      const pointCircle = new PIXI.Sprite();
      pointCircle.anchor.set(0.5);
      pointCircle.texture = this.circleTexture;
      pointCircle.tint = PIXI.utils.string2hex(this.color((point["x"] * point["x"]+ point["y"] * point["y"]) % 3));

      pointGfx.addChild(pointCircle);

      return pointGfx;
    },

    updateMinMax(point) {
      const minX = Math.min(this.minX, point["x"]);
      const maxX = Math.max(this.maxX, point["x"]);
      const minY = Math.min(this.minY, point["x"]);
      const maxY = Math.max(this.maxY, point["x"]);

      if (minX === this.minX && maxX === this.maxX && minY === this.minY && maxY === this.maxY) {
        return;
      }

      this.x.domain([minX, maxX]);
      this.y.domain([minY, maxY]);
      this.xAxis.call(d3.axisBottom(this.x));
      this.yAxis.call(d3.axisLeft(this.y));

      const scaleX = (this.maxX - this.minX) / (maxX - minX);
      const scaleY = (this.maxY - this.minY) / (maxY - minY);

      // freeze current points as static blurred background
      const canvas = this.app.renderer.plugins.extract.canvas(this.appContainer);
      // debug
      // canvas.style.border = '1px solid #999999';
      // this.$refs.debug.appendChild(canvas);

      const backgroundGfx = PIXI.Sprite.from(canvas);
      backgroundGfx.x = this.x(this.minX) - CIRCLE_SIZE * scaleX;
      backgroundGfx.y = this.y(this.maxY) - CIRCLE_SIZE * scaleY;
      backgroundGfx.width = Math.abs(this.x(this.maxX) - this.x(this.minX)) + 2 * CIRCLE_SIZE * scaleX;
      backgroundGfx.height = Math.abs(this.y(this.maxY) - this.y(this.minY)) + 2 * CIRCLE_SIZE * scaleY;
      // blurring changes dimensions, causes issues with rescaling, fading out with alpha=0.95 instead
      // const blurFilter = new PIXI.filters.BlurFilter();
      // blurFilter.blur = CIRCLE_SIZE;
      // backgroundGfx.filters = [blurFilter];
      backgroundGfx.alpha = 0.95;
      this.backgroundLayer.removeChildren();
      this.backgroundLayer.addChild(backgroundGfx);

      // remove all previous points
      this.pointLayer.removeChildren();

      // update min/max
      this.minX = minX;
      this.maxX = maxX;
      this.minY = minY;
      this.maxY = maxY;
    },

    addPoint(point) {
      this.updateMinMax(point);

      const pointGfx = this.createPointGfx(point, this.pointsCount);
      this.pointLayer.addChild(pointGfx);

      this.pointsCount++;
    },

    resetPoints() {
      this.minX = Infinity;
      this.maxX = -Infinity;
      this.minY = Infinity;
      this.maxY = -Infinity;

      this.x.domain([undefined, undefined]);
      this.y.domain([undefined, undefined]);
      this.xAxis.call(d3.axisBottom(this.x));
      this.yAxis.call(d3.axisLeft(this.y));

      this.backgroundLayer.removeChildren();
      this.pointLayer.removeChildren();

      this.pointsCount = 0;
    }
  },
};
</script>

<style scoped>
#container {
  width: 500px;
  height: 500px;
  margin: 0 auto;
  position: relative;
}
#d3-chart {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  width: 100%;
  height: 100%;
}
#pixi-chart {
  position: absolute;
}
</style>